public class Thermometre {
    // la temperature est stocke en Kelvin
    // Invariant: temperature >= 0
    protected double temperature;

    /** Construit un thermomètre à la température initialisé à une certaine valeur
     * 
     * @param temperature la température en Celsius
     */
    public Thermometre(double temperature) {
	this.temperature = temperature+273.15;
    }
    
    // Accesseurs
    /**
     * @return la température du thermomètre en degrés Celsius
     */
    public double getTemperatureCelsius() {
	return temperature-273.15;
    }

    /**
     * @return la température du thermomètre en degrés Kelvin
     */
    public double getTemperatureKelvin() {
	return  temperature;
    }

    /**
     * @return la température du thermomètre en degrés Farenheit
     */
    public double getTemperatureFarenheit() {
	return (9 / 5d) * temperature - 459.67;
    }

    // Un setter
    /** Règle la température du thermomètre
     * 
     * @param temperature la température en degrés Celsius
     * @throws RuntimeException si la température n'est pas valide, i.e. supérieure à 273.15
     */
    public void setTemperatureCelsius(double temperature) {
	if (temperature < -273.15) {
	    throw new RuntimeException("Temperature trop faible");
	}
	this.temperature = temperature + 273.15;
    }

    /**
     * Incrémente la température d'un degré Celsius
     */
    public void rechauffement(){
	temperature++;
    }

    /**
     * Décrémente la température d'un degré Celsius, si c'est possible
     */
    public void refroidissement(){
	if (temperature > 1) {
	    temperature--;
	}
    }
}
